.\" DAL DaGetRegister(3) manpage
.\"
.\"
.\" +============================================+
.\" |  Author:          Yury Georgievskiy, CERN  |
.\" |  Creation date:   08.05.2007               |
.\" +============================================+
.\"
.\"
.TH DAGETREGISTER "3" "May 2007" "Driver Access Library" "DAL User's Manual"
.SH NAME
DaGetRegister \- obtain register value
.SH SYNOPSIS
.B int DaGetRegister(HANDLE \fIhandle\fB, int \fIrId\fB, void* \fIbuf\fB, int \fIcount\fB);
.SH DESCRIPTION
The \fIDaGetRegister()\fR function attemps to get value of the register
\fIrId\fR. Each register consists of at \fBleast\fR one or more elements. In
case of one element - a register should be treated as \fBnormal\fR one. In case
of several elements one can consider such a \fBspecific\fR register either as a
set of the \fBnormal\fR registers (i.e. each element is a register itself) that
are grouped together for convenience, or it can be just	a chunk of memory with
several elements with a specified size. Number of register elements and their
size (note, \fIthat size of each element is identical!\fR) depends on the
register definition itself, and can be obtained by means of
\fIDaGetRegDepth()\fR and \fIDaGetRegSize()\fR library functions. It's up to
user to provide a buffer that should be big enough to hold obtained register
values. Buffer size (in bytes) is passed in \fIcount\fR parameter.
.TP
.I handle
- is a library handle, returned by \fIDaEnableAccess()\fR call
.TP
.I rId
- is an ID of a register that should be get ID of each Module register can be
found in \fI<ModuleName>RegId.h\fR file, which is located
in a standart include directory of a given Module:
\fI/ps/local/$(CPU)/drvrutil/include/<ModuleName>include\fR
.TP
.I buf
- is a pointer to buffer, where obtained data will be put
.TP
.I count
- is a buffer size in bytes
.SH RETURN VALUE
On success, \fITHE NUMBER OF OBTAINED REGISTER ELEMENTS\fR is returned. Each
register consists of at \fBleast\fR one element. So minimum returned number is
\fI1\fR. You can get register depth using \fIDaGetRegDepth()\fR function.
.sp
On failure the return code is:
.TP
.B -DA_ERR_B2S
- if provided buffer is not big enough
.TP
.B -DA_ERR_BAD_HANDLE
- provided handle is bad
.TP
.B -DA_ERR_NO_REG
- no such register
.TP
.B -DA_ERR_INT_ERR
- can't get register value for some reason. Error information is printing
on stderr if \fBDA_DBG_ERR_INFO\fR debug flag is set (see \fIDaDbgFlag()\fR
for more info about debug flags)
.TP
.B -DA_ERR_NOT_INIT
- library was not initialized, i.e. \fIDaEnableAccess()\fR was not called
.SH AUTHOR
Written by Yury Georgievskiy <ygeorgie@gmail.com>
.SH SEE ALSO
.BR driverGen (8),
.BR modinst (8),
.BR moduninst (8),
.BR dal (3),
.BR DaEnableAccess (3),
.BR DaDisableAccess (3),
.BR DaSetDefAM (3),
.BR DaGetDefAM (3),
.BR DaGetNodeFd (3),
.BR DaGetRegChunk (3),
.BR DaSetRegister (3),
.BR DaSetRegChunk (3),
.BR DaGetRegDepth (3),
.BR DaGetRegSize (3),
.BR DaGetRegRep (3),
.BR DaSetRegRep (3),
.BR DaGetRegAccessRights (3),
.BR DaGetRegName (3),
.BR DaDrvrVers (3),
.BR DaLibVers (3),
.BR DaDbgFlag (3),
.BR DaGetErrCode (3),
.BR DaUserEntryPoint (3)
